package data.missions.hadd_finalBonusScrapperMission2;

import com.fs.starfarer.api.combat.BattleObjectiveAPI;
import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;
import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

public class MissionDefinition implements MissionDefinitionPlugin {

	public void defineMission(MissionDefinitionAPI api) {

		// Set up the fleets
		api.initFleet(FleetSide.PLAYER, "ISS", FleetGoal.ATTACK, false, 10);
		api.initFleet(FleetSide.ENEMY, "ISS", FleetGoal.DEFEND, true, 10);

		// Set a blurb for each fleet
		api.setFleetTagline(FleetSide.PLAYER, "Remainder of the Corvus Alliance");
		api.setFleetTagline(FleetSide.ENEMY, "The Scrapyard Defense Force");
		
		// These show up as items in the bulleted list under 
		// "Tactical Objectives" on the mission detail screen
		api.addBriefingItem("Defeat the Titan Homeworld");
		api.addBriefingItem("Both the Heracles and the Radiance must survive.");
		
		// Set up the player's fleet
		api.addToFleet(FleetSide.PLAYER, "onslaught_Outdated", FleetMemberType.SHIP, "ISS Heracles", true, CrewXPLevel.ELITE);
		api.addToFleet(FleetSide.PLAYER, "enforcer_Assault", FleetMemberType.SHIP, false, CrewXPLevel.ELITE);
		api.addToFleet(FleetSide.PLAYER, "lasher_CS", FleetMemberType.SHIP, false, CrewXPLevel.VETERAN);
		api.addToFleet(FleetSide.PLAYER, "broadsword_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN);
		api.addToFleet(FleetSide.PLAYER, "piranha_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN);
		api.addToFleet(FleetSide.PLAYER, "paragon_Elite", FleetMemberType.SHIP, "ISS Radiance", true, CrewXPLevel.ELITE);
		api.addToFleet(FleetSide.PLAYER, "odyssey_Balanced", FleetMemberType.SHIP, false, CrewXPLevel.ELITE);
		api.addToFleet(FleetSide.PLAYER, "medusa_PD", FleetMemberType.SHIP, false, CrewXPLevel.VETERAN);
		api.addToFleet(FleetSide.PLAYER, "tempest_Attack", FleetMemberType.SHIP, false, CrewXPLevel.VETERAN);
		api.addToFleet(FleetSide.PLAYER, "wasp_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN);
		
		
		// Mark a ship as essential, if you want
		api.defeatOnShipLoss("ISS Heracles");
		api.defeatOnShipLoss("ISS Radiance");
		
		// Set up the enemy fleet
		api.addToFleet(FleetSide.ENEMY, "hadd_elitestriker_Elite", FleetMemberType.SHIP, "ISS Mettle", false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_homeworld_Titan", FleetMemberType.SHIP, "Titan Homeworld", true, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_sparrow_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.REGULAR).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_blade_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_blade_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_blade_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_blade_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_blade_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_blade_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_platypus_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_fang_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_fang_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_fang_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.ELITE).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_bat_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_bat_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_bat_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_raptor_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_raptor_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		api.addToFleet(FleetSide.ENEMY, "hadd_raptor_wing", FleetMemberType.FIGHTER_WING, false, CrewXPLevel.VETERAN).getCaptain().setPersonality("fearless");
		
		api.defeatOnShipLoss("Titan Homeworld");
		
		// Set up the map.
		float width = 20000f;
		float height = 20000f;
		api.initMap((float)-width/2f, (float)width/2f, (float)-height/2f, (float)height/2f);
		
		float minX = -width/2;
		float minY = -height/2;
		
		// All the addXXX methods take a pair of coordinates followed by data for
		// whatever object is being added.
		
		// Add three big nebula clouds
		api.addNebula(minX + width * 0.25f, minY + height * 0.75f, 3000);
		api.addNebula(minX + width * 0.75f, minY + height * 0.25f, 3000);
		
		// And a few random ones to spice up the playing field.
		// A similar approach can be used to randomize everything
		// else, including fleet composition.
		for (int i = 0; i < 5; i++) {
			float x = (float) Math.random() * width - width/2;
			float y = (float) Math.random() * height - height/2;
			float radius = 100f + (float) Math.random() * 400f; 
			api.addNebula(x, y, radius);
		}
		
		// Add objectives. These can be captured by each side
		// and provide stat bonuses and extra command points to
		// bring in reinforcements.
		// Reinforcements only matter for large fleets - in this
		// case, assuming a 100 command point battle size,
		// both fleets will be able to deploy fully right away.
		api.addObjective(minX + width * 0.47f, minY + height * 0.05f, "comm_relay", BattleObjectiveAPI.Importance.NORMAL);
		api.addObjective(minX + width * 0.53f, minY + height * 0.05f, "comm_relay", BattleObjectiveAPI.Importance.NORMAL);
		api.addObjective(minX + width * 0.47f, minY + height * 0.1f, "comm_relay", BattleObjectiveAPI.Importance.NORMAL);
		api.addObjective(minX + width * 0.53f, minY + height * 0.1f, "comm_relay", BattleObjectiveAPI.Importance.NORMAL);
		
		api.addObjective(minX + width * 0.45f, minY + height * 0.90f, "comm_relay");
		api.addObjective(minX + width * 0.45f, minY + height * 0.80f, "sensor_array");
		api.addObjective(minX + width * 0.55f, minY + height * 0.90f, "comm_relay");
		api.addObjective(minX + width * 0.55f, minY + height * 0.80f, "sensor_array");
		api.addObjective(minX + width * 0.33f, minY + height * 0.75f, "nav_buoy");
		api.addObjective(minX + width * 0.67f, minY + height * 0.75f, "nav_buoy");
		api.addObjective(minX + width * 0.45f, minY + height * 0.65f, "nav_buoy");
		api.addObjective(minX + width * 0.55f, minY + height * 0.65f, "nav_buoy");
		
		api.addAsteroidField(-(minY + height), minY + height, -45, 2000f,
								20f, 70f, 100);
	}

}






