package data.missions.unite;

import java.util.ArrayList;
import java.util.List;

import com.fs.starfarer.api.fleet.FleetGoal;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.mission.FleetSide;
import com.fs.starfarer.api.mission.MissionDefinitionAPI;
import com.fs.starfarer.api.mission.MissionDefinitionPlugin;

public class MissionDefinition implements MissionDefinitionPlugin {

	public void defineMission(MissionDefinitionAPI api) {

		// Set up the fleets
		api.initFleet(FleetSide.PLAYER, "MSV", FleetGoal.ATTACK, false, 5);
		api.initFleet(FleetSide.ENEMY, "ISS", FleetGoal.DEFEND, true);

		// Set a blurb for each fleet
		api.setFleetTagline(FleetSide.PLAYER, "Trade Scavengers");
		api.setFleetTagline(FleetSide.ENEMY, "Hegemony");
		
		// These show up as items in the bulleted list under 
		// "Tactical Objectives" on the mission detail screen
		api.addBriefingItem("Remember that the Scavengers' ships are repurposed trading vessels, they do not have the survivability of the dedicated warships that the Hegemony have.");
		
		// Set up the player's fleet
		api.addToFleet(FleetSide.PLAYER, "hades_barrage", FleetMemberType.SHIP, "MSV Hades", true);
		api.addToFleet(FleetSide.PLAYER, "valhalla_standard", FleetMemberType.SHIP, "MSV Valhalla", false);
		api.addToFleet(FleetSide.PLAYER, "genesis_standard", FleetMemberType.SHIP, "MSV Genesis", false);
		api.addToFleet(FleetSide.PLAYER, "scorpion_standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "scorpion_standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "lasher_faststandard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "lasher_faststandard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "lasher_faststandard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.PLAYER, "razor_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "razor_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "razor_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "razor_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.PLAYER, "razor_wing", FleetMemberType.FIGHTER_WING, false);


		
		
		// Set up the enemy fleet
		api.addToFleet(FleetSide.ENEMY, "onslaught_Outdated", FleetMemberType.SHIP, "ISS Glorious", false);
		api.addToFleet(FleetSide.ENEMY, "falcon_CS", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "falcon_CS", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "hammerhead_Balanced", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "hammerhead_Balanced", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "hammerhead_Balanced", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "lasher_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "lasher_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "lasher_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "lasher_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "lasher_Standard", FleetMemberType.SHIP, false);
		api.addToFleet(FleetSide.ENEMY, "broadsword_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.ENEMY, "broadsword_wing", FleetMemberType.FIGHTER_WING, false);
		api.addToFleet(FleetSide.ENEMY, "broadsword_wing", FleetMemberType.FIGHTER_WING, false);

		
		
		// Set up the map.
		float width = 20000f;
		float height = 12000f;
		api.initMap((float)-width/2f, (float)width/2f, (float)-height/2f, (float)height/2f);
	}

}






