package data.scripts.elder.world;

import java.awt.Color;
import java.util.List;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;
import com.fs.starfarer.api.fleet.FleetMemberType;

import data.scripts.world.*;

@SuppressWarnings( "unchecked" )
public class ElderSectorGen extends SectorGen
{
	public void generate( SectorAPI sector )
	{
		StarSystemAPI system = sector.getStarSystem( "Corvus" );

		// changed name of planet and moved away from star
		SectorEntityToken star = system.createToken( 0, 0 );
		SectorEntityToken non = system.addPlanet(star, "Corvex", "wdwarf", 230, 10, 17000, 10000);
		system.addAsteroidBelt (non, 300, 300, 500, 10, 45);	

		ElderSpawnPoint elderSpawn = new ElderSpawnPoint( sector, system, 10, 5, non );
		system.addSpawnPoint( elderSpawn );
		
		// system.addSpawnPoint( elderSpawn );
		// for( int i = 0; i < 6; ++i )
		// {
		  // elderSpawn.spawnFleet();
		// }
		
		// faction api's referenced by string to increase standalone compatibility
		FactionAPI elder = sector.getFaction( "elder" );
		elder.setRelationship( "hegemony",     -1 );
		elder.setRelationship( "tritachyon",   -1 );
		elder.setRelationship( "pirates",      -1 );
		elder.setRelationship( "TimCORP",      -1 );
		elder.setRelationship( "independent",  0 );
		elder.setRelationship( "nomads",       0 );
		elder.setRelationship( "junk_pirates", 0 );
		elder.setRelationship( "player",       0 );
		elder.setRelationship( "pur",       -1 );
	}
	
}
