package data.scripts.pur.world;

import java.awt.Color;
import java.util.List;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;
import com.fs.starfarer.api.fleet.FleetMemberType;

import data.scripts.world.*;

@SuppressWarnings( "unchecked" )
public class PurSectorGen extends SectorGen
{
	public void generate( SectorAPI sector )
	{
		StarSystemAPI system = sector.getStarSystem( "Corvus" );

		// changed name of planet and moved away from star
		SectorEntityToken star = system.createToken( 0, 0 );
		SectorEntityToken non = system.addPlanet(star, "Corvex", "wdwarf", 230, 10, 17000, 10000);
		system.addAsteroidBelt (non, 300, 300, 500, 10, 45);	

		PurSpawnPoint purSpawn = new PurSpawnPoint( sector, system, 15, 10, non );
		system.addSpawnPoint( purSpawn );
		
		
		// system.addSpawnPoint( purSpawn );
		// for( int i = 0; i < 7; ++i )
		// {
		  // purSpawn.spawnFleet();
		// }
		
		// faction api's referenced by string to increase standalone compatibility
		FactionAPI pur = sector.getFaction( "pur" );
		pur.setRelationship( "hegemony",     0 );
		pur.setRelationship( "tritachyon",   0 );
		pur.setRelationship( "pirates",      -1 );
		pur.setRelationship( "TimCORP",      -1 );
		pur.setRelationship( "independent",  0 );
		pur.setRelationship( "nomads",       0 );
		pur.setRelationship( "junk_pirates", -1 );
		pur.setRelationship( "player",       0 );
		pur.setRelationship( "elder",       -1 );
	}
	
}
