package data.scripts.pur.world;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;

import data.scripts.world.*;

public class PurSpawnPoint extends BaseSpawnPoint {

	public PurSpawnPoint(SectorAPI sector, LocationAPI location, 
							float daysInterval, int maxFleets, SectorEntityToken anchor) {
		super(sector, location, daysInterval, maxFleets, anchor);
	}

	@Override
	protected CampaignFleetAPI spawnFleet() {
		
		String type = null;
		float r = (float) Math.random();
		if (r > .9f) {
			type = "pur1";
		} else if (r > 0.8f) {
			type = "pur2";
		} else if (r > 0.5f) {
			type = "pur3";
		} else if (r > 0.3f) {
			type = "pur4";
		} else if (r > 0.2f) {
			type = "pur5";
		} else if (r > 0.15f) {
			type = "pur6";
		} else {
			type = "pur7";
		}
		
		CampaignFleetAPI fleet = getSector().createFleet("pur", type);
		getLocation().spawnFleet(getAnchor(), 0, 0, fleet);
		
		
		if (type.equals("pur1") || type.equals("pur2") || type.equals("pur3") || type.equals("pur4") || type.equals("pur5") || type.equals("pur6")){
			fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 30);
			fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
		} else {
			if ((float) Math.random() > 0.5f) {
				fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 30);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			} else {
				fleet.addAssignment(FleetAssignment.DEFEND_LOCATION, getAnchor(), 5);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			}
		}
		
		return fleet;
	}

}
