package data.scripts.world;

import java.util.ArrayList;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.CargoAPI;

public class CiviliansSpawnPoint extends BaseSpawnPoint 
{
 public CiviliansSpawnPoint(SectorAPI sector, LocationAPI location,float daysInterval, int maxFleets,SBGDatabase sbgd) 
	{super(sector, location, daysInterval, maxFleets, null);sbg_database=sbgd;}

	private SBGDatabase sbg_database;

	@Override
	protected CampaignFleetAPI spawnFleet() 
	{
	 ArrayList factions=new ArrayList();
	 factions.add("hegemony");
	 factions.add("independent");
	 factions.add("tritachyon");
	 factions.add("shipbuilders_guild");
	 String faction=(String)(factions.get((int)(Math.random()*factions.size())));
			 
	 float angle = (float) ((float) Math.random() * Math.PI * 2f);
	 float x = (float) (Math.cos(angle) * 15000f);
	 float y = (float) (Math.sin(angle) * 15000f);
	 SectorEntityToken spawnPoint = getLocation().createToken(x, y);					
													
	 StarSystemAPI system = getSector().getStarSystem("Corvus");
	 String station_name=SBGDatabase.select_station(system);
	 SectorEntityToken station=system.getEntityByName(station_name);
	
	 CampaignFleetAPI fleet = getSector().createFleet(faction, "traveler");
	 getLocation().spawnFleet(spawnPoint, 0, 0, fleet);

	 fleet.addAssignment(FleetAssignment.RESUPPLY, station, 1000);
	 fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, spawnPoint, 1000);
	

	 return fleet;	
	}


}