package data.scripts.world;

import java.awt.Color;
import java.util.List;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;
import com.fs.starfarer.api.fleet.FleetMemberType;

@SuppressWarnings("unchecked")
public class InterstellarFederationSectorGen implements SectorGeneratorPlugin {

	public void generate(SectorAPI sector) {
		
		StarSystemAPI system = sector.getStarSystem("Corvus");
		SectorEntityToken sol = system.createToken(0, 0);
		
		SectorEntityToken station3 = system.addOrbitalStation(sol, 275, 14000, 400, "System Outpost", "interstellarFederation");

		float angle = (float) ((float) Math.random() * Math.PI * 2f);
		float x = (float) (Math.cos(angle) * 17000f);
		float y = (float) (Math.sin(angle) * 17000f);
		SectorEntityToken IFconvoy = system.createToken(x, y);
		system.addSpawnPoint(new InterstellarFederationConvoySpawnPoint(sector, system, 8, 1, IFconvoy, station3));
		
		InterstellarFederationSpawnPoint IFSpawn = new InterstellarFederationSpawnPoint(sector, system, 5, 5, station3);
		system.addSpawnPoint(IFSpawn);
		
		for (int i = 0; i < 6; ++i ) IFSpawn.spawnFleet();	

                FactionAPI interstellarFederation = sector.getFaction("interstellarFederation");

		CargoAPI IFcargo = station3.getCargo();
		IFcargo.addWeapons("annihilatorpod", 3);
		IFcargo.addWeapons("arbalest", 3);
		IFcargo.addWeapons("chaingun", 3);
		IFcargo.addWeapons("gauss", 3);
		IFcargo.addWeapons("heatseeker", 3);
		IFcargo.addWeapons("heavyac", 3);
		IFcargo.addWeapons("HV50", 9);
		IFcargo.addWeapons("HV75", 6);
		IFcargo.addWeapons("HV100", 3);
		IFcargo.addWeapons("cain", 1);
		IFcargo.addWeapons("citadelpd", 1);
		IFcargo.addWeapons("massdriver", 2);
		IFcargo.addWeapons("hadron", 1);
		IFcargo.addWeapons("heavyac", 3);
		IFcargo.addWeapons("heavymauler", 3);
		IFcargo.addWeapons("heavyneedler", 3);
		IFcargo.addWeapons("hveldriver", 6);
		IFcargo.addWeapons("ioncannon", 6);
		IFcargo.addWeapons("lightdualac", 6);
		IFcargo.addWeapons("lightdualmg", 3);
		IFcargo.addWeapons("lightneedler", 9);
		IFcargo.addWeapons("locktide", 3);
		IFcargo.addWeapons("pdlaser", 3);
		IFcargo.addWeapons("railgun", 12);
		IFcargo.addWeapons("riptide", 3);
		IFcargo.addWeapons("shredder", 3);
		IFcargo.addWeapons("vulcan", 6);
		IFcargo.addWeapons("lancer", 6);
		IFcargo.addWeapons("thunderchief", 6);
		IFcargo.addWeapons("lancer_dual", 6);
		IFcargo.addWeapons("lancer_single", 6);
		IFcargo.addWeapons("piranha", 6);
		IFcargo.addWeapons("lightag", 12);
		IFcargo.addCrew(CrewXPLevel.VETERAN, 40);
		IFcargo.addCrew(CrewXPLevel.REGULAR, 120);
		IFcargo.addCrew(CrewXPLevel.GREEN, 360);
		IFcargo.addMarines(120);
		IFcargo.addMarines(120);
		IFcargo.addSupplies(500);
		IFcargo.addSupplies(500);
		IFcargo.addSupplies(500);
		IFcargo.addFuel(500);
		IFcargo.addFuel(500);
		IFcargo.addFuel(500);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "echo_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "echo_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "echo_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "rickshaw_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "rickshaw_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "rickshaw_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "dakota_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "dakota_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "dakota_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "titan_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "scythe_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "scythe_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "orion_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "orion_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "shogun_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "shogun_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "vixen_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "vixen_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "defiant_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "ares_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "antares_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "toa_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "auria_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "mazerk_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "tahoe_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "trexel_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "ballista_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "mercury_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "yukon_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "zephyr_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "montana_Hull", null);
		IFcargo.addMothballedShip(FleetMemberType.SHIP, "albatross_Hull", null);
		
		
		IFcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "draken_wing", null);
		IFcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "draken_wing", null);
		IFcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "hornet_wing", null);	
		IFcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "tracer_wing", null);
		IFcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "foxbat_wing", null);
		IFcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "foxbat_wing", null);		

		interstellarFederation.setRelationship("hegemony", -1);
		interstellarFederation.setRelationship("tritachyon", -1);
		interstellarFederation.setRelationship("pirates", -1);
		interstellarFederation.setRelationship("independent", -1);       
    
	}
	
}
