package data.scripts.world;

import java.util.List;
import java.util.ArrayList;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.Script;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.fleet.FleetMemberType;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;


 public class SBGDatabase
 {
  public SBGDatabase() {init_weapons();init_hulls();} 

  private static List clone(List l)
  {
   List cl=new ArrayList();
   for (int i=0;i<l.size();++i)
	cl.add(l.get(i));
   return cl;	
  }

  public static String select_station(StarSystemAPI system)
	{
	 List available_stations=clone(system.getOrbitalStations());
	 available_stations.remove(system.getEntityByName("Abandoned Storage Facility"));
	 SectorEntityToken t=(SectorEntityToken)available_stations.get((int)(Math.random()*available_stations.size()));
	 return (String)(t.getName());
	}



  public void add_hulls(CargoAPI cargo,int type_bb,int type_cc,int type_dd,int type_ff,int type_ww)
   {
    for (int i=0;i<type_bb;++i) add_random_hull(cargo,battleship_list);
	for (int i=0;i<type_cc;++i) add_random_hull(cargo,cruiser_list);
	for (int i=0;i<type_dd;++i) add_random_hull(cargo,destroyer_list);
	for (int i=0;i<type_ff;++i) add_random_hull(cargo,frigate_list);
	for (int i=0;i<type_ww;++i) add_random_wing(cargo);
   }

   private void add_random_hull(CargoAPI cargo,ArrayList hulls_list)
   {
	for(;;)
		{
		 int idx = (int)(Math.random()*hulls_list.size());
		 String name=(String)hulls_list.get(idx);

		 boolean added=true;
		 try {cargo.addMothballedShip(FleetMemberType.SHIP, name, null);}
		 catch (Exception e) {added=false;}
		 if (added==true) return;
		 hulls_list.remove(idx);
		}	
   }
	 /*
   public void add_wings(CargoAPI cargo,int type_n)
   {
    for (int i=0;i<type_n;++i) add_random_wing(cargo);
   }	*/

   private void add_random_wing(CargoAPI cargo)
   {
	for(;;)
		{
		 int idx = (int)(Math.random()*wings_list.size());
		 String name=(String)wings_list.get(idx);

		 boolean added=true;
		 try {cargo.addMothballedShip(FleetMemberType.FIGHTER_WING, name, null);}
		 catch (Exception e) {added=false;}
		 if (added==true) return;
		 wings_list.remove(idx);
		}	
   }


   public void add_random_weapons(SectorAPI sector,CargoAPI cargo,int type_n,int min)
   {add_random_weapons(sector,cargo,type_n,min,min);}
   
   public void add_random_weapons(SectorAPI sector,CargoAPI cargo,int type_n,int min,int max)
   {
    if (type_n<1 || min<1) return;
	if (max<min) max=min;
	List weaponIds = sector.getAllWeaponIds();
	for (int i = 0; i < type_n; i++) 
		{
		 String weaponId = (String) weaponIds.get((int) (weaponIds.size() * Math.random()));
		 int quantity = (int)(Math.random() * (float)(max-min) + min);
		 cargo.addWeapons(weaponId, quantity);
		}
   }

   public void add_wp_weapons(CargoAPI cargo,int type_n,int min)
   {add_wp_weapons(cargo,type_n,min,min);}

   public void add_wp_weapons(CargoAPI cargo,int type_n,int min,int max)
   {
    if (type_n<1 || min<1) return;
	if (max<min) max=min;
	for (int i = 0; i < type_n; i++) 
		{
		 String weaponId = (String) wp_weapons.get((int) (wp_weapons.size() * Math.random()));
		 int quantity = (int)(Math.random() * (float)(max-min) + min);
		 quantity=Math.min(quantity,max);
		 cargo.addWeapons(weaponId, quantity);
		}
   } 

   private ArrayList wp_weapons;

   private void init_weapons()
   {
	wp_weapons=new ArrayList();
	wp_weapons.add("triplehveld");
	wp_weapons.add("hvy_laser");
	wp_weapons.add("hvy_amblaster");
	wp_weapons.add("impalerburst");
	wp_weapons.add("guardian");
	wp_weapons.add("dualheavyblaster");
	wp_weapons.add("demolitionblaster");
	wp_weapons.add("lightblaster");
	wp_weapons.add("heavygravitonbeam");
	wp_weapons.add("atroposlauncher");
	wp_weapons.add("mirv_sabot_launcher");
	wp_weapons.add("light_flak");
	wp_weapons.add("heavy_flak");
	wp_weapons.add("swarmers_rack");
	wp_weapons.add("raptors_rack");
	wp_weapons.add("mirv_blizzard_launcher");
	wp_weapons.add("raptor");
	wp_weapons.add("raptor_pod");
	wp_weapons.add("swarmer_pod");
	wp_weapons.add("sabotsrmlauncher");
	wp_weapons.add("harpoonlauncher");
	wp_weapons.add("salamanderlauncher");
	wp_weapons.add("barricade_launcher");
	wp_weapons.add("heavy_taclaser");
	wp_weapons.add("artillery");
	wp_weapons.add("disintegrator");
	wp_weapons.add("gatling_gun");
	wp_weapons.add("pilum_large_launcher");
	wp_weapons.add("harpoon_large_launcher");
	wp_weapons.add("sabot_large_launcher");
	wp_weapons.add("annihilator_medium_launcher");	  
	wp_weapons.add("barricade_pod");
	wp_weapons.add("ultra_ac");	  
	wp_weapons.add("buckshot_cannon");
	wp_weapons.add("charger_rack");
	wp_weapons.add("charger_launcher");
	wp_weapons.add("armageddon_rack");
	wp_weapons.add("mercury_rack");
	wp_weapons.add("quad_heavy_mg");
	wp_weapons.add("light_graviton_beam");
	wp_weapons.add("emp_torpedo_rack");
	wp_weapons.add("charger_large_launcher");		
	wp_weapons.add("atropos_large_launcher");
	wp_weapons.add("armageddon_large_launcher");   
	wp_weapons.add("mercury_launcher");
	wp_weapons.add("mirv_emp_launcher");
	wp_weapons.add("light_phasebeam");
	wp_weapons.add("barricade_large_launcher");
   }

  private ArrayList wings_list;
  private ArrayList frigate_list;
  private ArrayList destroyer_list;
  private ArrayList cruiser_list;
  private ArrayList battleship_list;

  private void init_hulls()
  {
   battleship_list=new ArrayList();
   cruiser_list=new ArrayList();
   destroyer_list=new ArrayList();
   frigate_list=new ArrayList();
   wings_list=new ArrayList();

   add_stock_hulls();
   add_wp_hulls();		add_wp_hulls();add_wp_hulls();//3x
   add_junk_pirates_hulls();
   add_gun_runners_hulls();
   add_mod_pack_hulls();
   add_sf_extended_hulls();
   add_nomads_hulls();
   add_scrappers_hulls();
   add_hoplites_hulls();
   add_timcorp_hulls();
   add_lotus_hulls();
   add_interstellar_federation_hulls();
   add_starfarerplus_hulls();
  }

  private void add_stock_hulls()
  {
   frigate_list.add("wolf_Hull");
   frigate_list.add("hound_Hull");
   frigate_list.add("hyperion_Hull");
   frigate_list.add("shuttle_Hull");
   frigate_list.add("lasher_Hull");
   frigate_list.add("omen_Hull");
   frigate_list.add("tempest_Hull");
   frigate_list.add("brawler_Hull");
   frigate_list.add("vigilance_Hull");
   frigate_list.add("dram_Hull");
   destroyer_list.add("hammerhead_Hull");
   destroyer_list.add("sunder_Hull");
   destroyer_list.add("condor_Hull");
   destroyer_list.add("enforcer_Hull");
   destroyer_list.add("buffalo_Hull");
   destroyer_list.add("gemini_Hull");	
   destroyer_list.add("tarsus_Hull");
   destroyer_list.add("valkyrie_Hull");
   destroyer_list.add("buffalo2_Hull");
   destroyer_list.add("medusa_Hull");
   cruiser_list.add("falcon_Hull");
   cruiser_list.add("eagle_Hull");
   cruiser_list.add("venture_Hull");
   cruiser_list.add("apogee_Hull");
   cruiser_list.add("dominator_Hull");
   cruiser_list.add("aurora_Hull");
   battleship_list.add("onslaught_Hull");
   battleship_list.add("astral_Hull");
   battleship_list.add("atlas_Hull");
   battleship_list.add("conquest_Hull");
   battleship_list.add("paragon_Hull");
   battleship_list.add("odyssey_Hull");

   wings_list.add("talon_wing");
   wings_list.add("dagger_wing");
   wings_list.add("wasp_wing");
   wings_list.add("xyphos_wing");
   wings_list.add("broadsword_wing");
   wings_list.add("piranha_wing");
   wings_list.add("trident_wing");
   wings_list.add("longbow_wing");
   wings_list.add("mining_drone_wing");
   wings_list.add("gladius_wing");
   wings_list.add("warthog_wing");
   wings_list.add("thunder_wing");
  }

  private void add_wp_hulls()  //0.27
  {
   cruiser_list.add("bolter_Hull");	
   cruiser_list.add("flounder_Hull");
   battleship_list.add("subjugator_Hull");
   cruiser_list.add("aurora2_Hull");
   battleship_list.add("devastator_Hull");
   cruiser_list.add("imp_Hull");
   destroyer_list.add("pillager_Hull");
   frigate_list.add("spearhead2_Hull");
   frigate_list.add("ghost_Hull");  
   cruiser_list.add("redoubt_Hull");
   destroyer_list.add("wraith_Hull");
   destroyer_list.add("plus_torment_Hull");
   destroyer_list.add("barrage_Hull");
   destroyer_list.add("specter_Hull");
   cruiser_list.add("devil_Hull");
   cruiser_list.add("harpy_Hull");
   battleship_list.add("twilight_Hull");
   destroyer_list.add("scorcher_Hull");
   
   wings_list.add("pest_wing");
   wings_list.add("pyro_wing");
   wings_list.add("barracuda_wing");
   wings_list.add("crossbow_wing");
   wings_list.add("bayonet_wing");
   wings_list.add("scourge_wing");
  }

  private void add_junk_pirates_hulls()	  //1.15
  {
   frigate_list.add("junk_pirates_sickle_Hull");
   frigate_list.add("junk_pirates_hammer_Hull");
   frigate_list.add("junk_pirates_clam_Hull");
   frigate_list.add("junk_pirates_stoatA_Hull");
   frigate_list.add("junk_pirates_stoatB_Hull");
   cruiser_list.add("junk_pirates_dugong_Hull");
   battleship_list.add("junk_pirates_orca_Hull");
   destroyer_list.add("junk_pirates_langoustine_Hull");
   destroyer_list.add("junk_pirates_boxenstein_Hull");
   destroyer_list.add("junk_pirates_boxer_Hull");
   destroyer_list.add("junk_pirates_octopus_Hull");
   destroyer_list.add("junk_pirates_scythe_Hull");
   cruiser_list.add("junk_pirates_goat_Hull");
   
   wings_list.add("junk_pirates_spike_wing");
   wings_list.add("junk_pirates_cleat_wing");
   wings_list.add("junk_pirates_shard_wing");
  }

  private void add_gun_runners_hulls()	//1.04
  {
   destroyer_list.add("GR_Gorgon_Hull");
   cruiser_list.add("GR_Hades_Hull");
   destroyer_list.add("GR_Paria_Hull");
   frigate_list.add("GR_Helios_Hull");	   
  }

  private void add_hoplites_hulls()	//0.3
  {
   frigate_list.add("hc_marpesia_Hull");
   frigate_list.add("hc_machai_Hull");
   frigate_list.add("hc_cratus_Hull");
   cruiser_list.add("hc_soteria_Hull");
   battleship_list.add("hc_heracles_Hull");

   wings_list.add("hc_dory_wing");
  }

  private void add_scrappers_hulls()  //1.25
  {
   frigate_list.add("hadd_exxon_Hull");
   frigate_list.add("hadd_stonehead_Hull");
   frigate_list.add("hadd_refuge_Hull");
   frigate_list.add("hadd_vice_Hull");			 
   frigate_list.add("hadd_bite_Hull");			 
   frigate_list.add("hadd_manta_Hull");
   frigate_list.add("hadd_turtle_Hull");
   destroyer_list.add("hadd_beast_Hull");			 
   destroyer_list.add("hadd_menace_Hull");			 
   destroyer_list.add("hadd_striker_Hull");	
   cruiser_list.add("hadd_terra_Hull");			 
   cruiser_list.add("hadd_juggernaut_Hull");			 
   battleship_list.add("hadd_homeworld_Hull");	
   battleship_list.add("hadd_battleborn_Hull");	  
   frigate_list.add("hadd_array_Hull");
   cruiser_list.add("hadd_halberd_Hull");	
   //destroyer_list.add("hadd_elitestriker_Hull");			 	 
				 
   wings_list.add("hadd_fang_wing");
   wings_list.add("hadd_sparrow_wing");
   wings_list.add("hadd_bat_wing");
   wings_list.add("hadd_platypus_wing");
   wings_list.add("hadd_raptor_wing");
   wings_list.add("hadd_blade_wing");
  }

  private void add_nomads_hulls() //0.8
  {
   battleship_list.add("nom_gila_monster_Hull");
   destroyer_list.add("nom_komodo_Hull");
   frigate_list.add("nom_yellowjacket_Hull");
   frigate_list.add("nom_wurm_Hull");
   destroyer_list.add("nom_scorpion_Hull");	  
   battleship_list.add("nom_sandstorm_Hull");

   wings_list.add("nom_iguana_wing");
   wings_list.add("nom_scarab_wing");
  }

  private void add_lotus_hulls()  //1.10
  {
   frigate_list.add("argos_Hull");
   frigate_list.add("blizzard_Hull");
   frigate_list.add("jackal_Hull");
   destroyer_list.add("hydra_Hull");
   cruiser_list.add("eventide_Hull");
   battleship_list.add("vanquish_Hull");
   frigate_list.add("pointer_Hull");
   frigate_list.add("cerberus_Hull");
   destroyer_list.add("arcadia_Hull");
   destroyer_list.add("rive_Hull");
   destroyer_list.add("ajax_Hull");			
   frigate_list.add("stingray_Hull");		 
   frigate_list.add("aria_Hull");
   battleship_list.add("intrepid_Hull");
   frigate_list.add("vengeance_Hull");
									  
   wings_list.add("bolt_wing");
   wings_list.add("cutlass_wing");
   wings_list.add("stigma_wing");
   wings_list.add("javelin_wing"); 
   wings_list.add("sarissa_wing");
  }

  private void add_mod_pack_hulls()
  {
   cruiser_list.add("riht_Hull");
   cruiser_list.add("lyft_Hull");
   battleship_list.add("parrot_Hull");
   destroyer_list.add("pelican_Hull");                        
   cruiser_list.add("rapier_Hull");
   destroyer_list.add("dachsund_Hull");
   destroyer_list.add("bloodhound_Hull");
   cruiser_list.add("deco_Hull");
   destroyer_list.add("cerebus_Hull");
   frigate_list.add("dart_Hull");
   frigate_list.add("hobbler_Hull");
   frigate_list.add("mended_Hull");
   destroyer_list.add("grizzly_Hull");
   cruiser_list.add("boomer_Hull");
   frigate_list.add("barrister_Hull");
   frigate_list.add("boom_Hull");
   frigate_list.add("chiron_Hull");
   frigate_list.add("phalanx_Hull");
   frigate_list.add("snap_Hull");
   frigate_list.add("tourbus_Hull");
   destroyer_list.add("vermin_Hull");
   cruiser_list.add("ursidae_Hull");
   battleship_list.add("elite_boomer_Hull");
  }


  private void add_sf_extended_hulls()	  //0.25
  {
   cruiser_list.add("centipede_Hull");
   cruiser_list.add("owl_Hull");
   cruiser_list.add("dragoon_Hull");
   cruiser_list.add("goose_Hull");
   cruiser_list.add("goosemk2_Hull  ");
   cruiser_list.add("gate_Hull");
   cruiser_list.add("creeper_Hull ");
   destroyer_list.add("aghast_Hull");
   destroyer_list.add("mynar_Hull");
   destroyer_list.add("sheperd_Hull");
   destroyer_list.add("fireant_Hull");
   destroyer_list.add("tipi_Hull");
   battleship_list.add("oort_Hull");
   destroyer_list.add("scarab_Hull");
   destroyer_list.add("assel_Hull");

   wings_list.add("sparrow_wing");
  }
  
  
  private void add_timcorp_hulls()	//1.6
  {
   frigate_list.add("dux_Hull");
   frigate_list.add("zeta_Hull");
   frigate_list.add("upsilon_Hull");

   destroyer_list.add("rho_Hull");
   destroyer_list.add("lictor_Hull");
   destroyer_list.add("lictor2_Hull");
   destroyer_list.add("regulator_Hull");
   destroyer_list.add("executor_Hull");
   destroyer_list.add("omega_Hull"); 
   destroyer_list.add("eta_Hull");
   destroyer_list.add("katraid_arrowhead_Hull");
   destroyer_list.add("sentinel_Hull");
  
   cruiser_list.add("dictator_Hull");
   cruiser_list.add("beta_Hull");
   cruiser_list.add("alpha_Hull");
   cruiser_list.add("iota_Hull");  
   cruiser_list.add("censor_Hull");		 
   cruiser_list.add("theta_Hull");
   cruiser_list.add("angio_Hull");

   battleship_list.add("rex_Hull");
   battleship_list.add("caesar_Hull");
   battleship_list.add("consul_Hull");
   battleship_list.add("gamma_Hull");	 
   battleship_list.add("ksi_Hull");
   battleship_list.add("delta_Hull");
   battleship_list.add("delta2_Hull");
 
   wings_list.add("phi_wing");
   wings_list.add("kappa_wing");
   wings_list.add("psi_wing");
   wings_list.add("kappa_wing");		 
   wings_list.add("katana_wing");
   wings_list.add("spatha_wing");
   wings_list.add("omicron_wing");
  } 

  private void add_interstellar_federation_hulls()	//1.2.1
  {
   wings_list.add("hornet_wing");
   wings_list.add("draken_wing");
   wings_list.add("tracer_wing");
   wings_list.add("foxbat_wing");

   frigate_list.add("scythe_Hull"); 
   frigate_list.add("dakota_Hull");
   frigate_list.add("orion_Hull");
   frigate_list.add("rickshaw_Hull");	 
   frigate_list.add("echo_Hull");
   frigate_list.add("albatross_Hull");
   destroyer_list.add("defiant_Hull");
   destroyer_list.add("shogun_Hull");
   destroyer_list.add("vixen_Hull");
   destroyer_list.add("toa_Hull");
   destroyer_list.add("tahoe_Hull");	  
   destroyer_list.add("trexel_Hull");
   destroyer_list.add("zephyr_Hull");
   cruiser_list.add("ares_Hull");	  
   cruiser_list.add("mazerk_Hull");	     
   cruiser_list.add("ballista_Hull");
   cruiser_list.add("montana_Hull");
   cruiser_list.add("mercury_Hull");
   battleship_list.add("antares_Hull");
   battleship_list.add("titan_Hull");  
   battleship_list.add("auria_Hull");
   battleship_list.add("yukon_Hull");    
  }

  private void add_starfarerplus_hulls()   //1.01
  {
   wings_list.add("plus_tachy");
   wings_list.add("plus_amy");
   wings_list.add("plus_longsword");
   wings_list.add("plus_ballast");
   wings_list.add("plus_argon");
   wings_list.add("plus_pitbull");

   frigate_list.add("plus_spearhead");
   frigate_list.add("plus_axehead");
   frigate_list.add("plus_brawler2");
   frigate_list.add("plus_mastiff");
   frigate_list.add("plus_buckler");
   frigate_list.add("plus_hhyperion");
   frigate_list.add("plus_feral");
   frigate_list.add("plus_leopard");
   frigate_list.add("plus_nova");

   destroyer_list.add("plus_stilletto");
   destroyer_list.add("plus_bloodhawk");
   destroyer_list.add("plus_seagull");
   destroyer_list.add("plus_pestilence");
   destroyer_list.add("plus_taurus");
   destroyer_list.add("plus_torment");
   destroyer_list.add("plus_moth");
   destroyer_list.add("plus_saintbernard");
   destroyer_list.add("plus_barnacle");
   destroyer_list.add("plus_torment");

   cruiser_list.add("plus_slaughter");
   cruiser_list.add("plus_vulture");
   cruiser_list.add("plus_puma");
   cruiser_list.add("plus_death");
   cruiser_list.add("plus_epitaph");
   cruiser_list.add("plus_mammoth");
   cruiser_list.add("plus_templar");
   cruiser_list.add("plus_raven");

   battleship_list.add("plus_parrot");
   battleship_list.add("plus_scythe");
   battleship_list.add("plus_zeus");
  }
  
}























  
  