package data.scripts.world;

import java.awt.Color;
import java.util.List;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;
import com.fs.starfarer.api.fleet.FleetMemberType;

@SuppressWarnings("unchecked")
public class WPSectorGen implements SectorGeneratorPlugin {

	public void generate(SectorAPI sector) 
	{		
	 StarSystemAPI system = sector.getStarSystem("Corvus");
	 
	 MercenarySpawnPoint msp=new MercenarySpawnPoint(sector, system, 7, 5);
	 system.addSpawnPoint(msp);
	 
	 initFactionRelationships(sector);
	 msp.spawnFleet();	 
	 //msp.spawnFleet();
	 //msp.spawnFleet();

	 SBGDatabase sbgd=new SBGDatabase();

	 ShipBuildersGuildSpawnPoint sbgsp=new ShipBuildersGuildSpawnPoint(sector, system, 13, 3,sbgd);
	 system.addSpawnPoint(sbgsp);

	 SBGExecutiveSpawnPoint sbgesp=new SBGExecutiveSpawnPoint(sector, system, 4, 6,sbgd);
	 system.addSpawnPoint(sbgesp);

	 CiviliansSpawnPoint csp=new CiviliansSpawnPoint(sector, system, 1, 6,sbgd);
	 system.addSpawnPoint(csp);
	
	 SectorEntityToken station;
	 CargoAPI cargo;

	 station=system.getEntityByName("Orbital Station");
	 cargo=station.getCargo();
	 cargo.addMothballedShip(FleetMemberType.SHIP, "barrage_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "barrage_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "barracuda_wing", null);
	 cargo.addWeapons("buckshot_cannon", 2);
	 cargo.addWeapons("raptor", 2);	
	 cargo.addWeapons("raptor_pod", 2);		 
	 cargo.addWeapons("light_flak", 2);
	 cargo.addWeapons("barricade_launcher", 2);
	 cargo.addWeapons("annihilator_medium_launcher", 2);

	 station=system.getEntityByName("Corporate HQ");
	 cargo=station.getCargo();
	 cargo.addMothballedShip(FleetMemberType.SHIP, "bolter_Hull", null);	 
	 cargo.addMothballedShip(FleetMemberType.SHIP, "aurora2_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "aurora2_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "imp_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "pillager_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "pillager_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "bayonet_wing", null);
	 cargo.addWeapons("heavy_taclaser", 2);
	 cargo.addWeapons("light_graviton_beam", 2);
	 cargo.addWeapons("lightblaster", 2);
	 cargo.addWeapons("charger_rack", 2);
	 cargo.addWeapons("charger_launcher", 2);

	 station=system.getEntityByName("Hidden Base");
	 cargo=station.getCargo();
	 cargo.addMothballedShip(FleetMemberType.SHIP, "subjugator_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "devastator_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "spearhead2_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "spearhead2_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "plus_torment_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "plus_torment_Hull", null);
	 cargo.addMothballedShip(FleetMemberType.SHIP, "flounder_Hull", null);	  
	 cargo.addWeapons("sabotsrmlauncher", 2);
	 cargo.addWeapons("harpoonlauncher", 2);
	 cargo.addWeapons("gatling_gun", 2);
	 cargo.addWeapons("mercury_rack", 2);
	 cargo.addWeapons("mercury_launcher", 2);
	}
	
	private void initFactionRelationships(SectorAPI sector) 
	{
	 FactionAPI mercenary=sector.getFaction("mercenary");
	 
	 mercenary.setRelationship("hegemony", -1);
	 mercenary.setRelationship("tritachyon", -1);
	 mercenary.setRelationship("pirates", 0);
	 mercenary.setRelationship("independent", 0);
     mercenary.setRelationship("player", 0);
		
	}
	

}
















