package data.scripts.world.corvus;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.StarSystemAPI;

import data.scripts.world.BaseSpawnPoint;

public class GRPirateSpawnPoint extends BaseSpawnPoint {

	public GRPirateSpawnPoint(SectorAPI sector, LocationAPI location, 
							float daysInterval, int maxFleets, SectorEntityToken anchor) {
		super(sector, location, daysInterval, maxFleets, anchor);
	}

	@Override
	protected CampaignFleetAPI spawnFleet() {
		//if ((float) Math.random() < 0.5f) return null;
		
		String type = null;
		float r = (float) Math.random();
		if (r > 0.6f) {
			type = "raiders2";
		} else if (r > 0.28f) {
			type = "attackFleet";
		} else if (r > 0.06f) {
			type = "carrierGroup";
		} else {
			type = "armada";
		}
		
		CampaignFleetAPI fleet = getSector().createFleet("pirates", type);
		getLocation().spawnFleet(getAnchor(), 0, 0, fleet);
		
		StarSystemAPI system = getSector().getStarSystem("Corvus");
    SectorEntityToken station = system.getEntityByName("Orbital Depot");
    
    fleet.addAssignment(FleetAssignment.RESUPPLY, station, 1000);

    if (type.equals("raiders2") || type.equals("attackFleet")) {
			fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 30);
			fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
		} else {
			if ((float) Math.random() > 0.5f) {
				fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 30);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			} else {
				fleet.addAssignment(FleetAssignment.DEFEND_LOCATION, getAnchor(), 30);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			}
		}
		
		return fleet;
	}

}
