package data.scripts.world;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;

public class hadd_ScrapperSpawnPoint extends BaseSpawnPoint {

	public hadd_ScrapperSpawnPoint(SectorAPI sector, LocationAPI location, 
							float daysInterval, int maxFleets, SectorEntityToken anchor) {
		super(sector, location, daysInterval, maxFleets, anchor);
	}

	@Override
	protected CampaignFleetAPI spawnFleet() {
		//if ((float) Math.random() < 0.5f) return null;
		
		String type = null;
		float r = (float) Math.random();
		if (r > .75f) { // 25%
			type = "scout";
		} else if (r > 0.55f) { //20%
			type = "scout2";
		} else if (r > 0.40f) { //15%
			type = "team1";
		} else if (r > 0.25f) { //15%
			type = "team2";
		} else if (r > 0.13f) { //12%
			type = "smallCarrier";
		} else if (r > 0.6f) { //7%
			type = "assault";
		} else if (r > 0.02f) { //4%
			type = "carrierGroup";
		} else { //
			type = "invasion"; //2%
		}
		
		CampaignFleetAPI fleet = getSector().createFleet("scrappers", type);
		getLocation().spawnFleet(getAnchor(), 0, 0, fleet);
		
		
		if (type.equals("scout") || type.equals("scout2") || type.equals("team1") || type.equals("team2") || type.equals("smallCarrier") || type.equals("assault") || type.equals("carrierGroup") || type.equals("invasion")) {
			fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 10);
			fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
		} else {
			if ((float) Math.random() > 0.5f) {
				fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 30);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			} else {
				fleet.addAssignment(FleetAssignment.DEFEND_LOCATION, getAnchor(), 20);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			}
		}
		
		return fleet;
	}

}
