package data.scripts.world;

import java.awt.Color;
import java.util.List;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;

import com.fs.starfarer.api.campaign.CargoAPI;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.SectorGeneratorPlugin;
import com.fs.starfarer.api.campaign.StarSystemAPI;
import com.fs.starfarer.api.campaign.CargoAPI.CrewXPLevel;
import com.fs.starfarer.api.fleet.FleetMemberType;

@SuppressWarnings("unchecked")
public class neutrinoGen implements SectorGeneratorPlugin {

	public void generate(SectorAPI sector) {
	
    StarSystemAPI system = sector.getStarSystem("Corvus");
    		
		SectorEntityToken sol = system.createToken(0, 0);
    		SectorEntityToken token = system.createToken(2000, 15000);
		SectorEntityToken NCstation = system.addOrbitalStation(sol, 270, 800, 75, "Solar Powerplant", "neutrinocorp");
		system.addSpawnPoint(new neutrinoConvoySpawnPoint(sector, system, 7, 1, token, NCstation));
		neutrinoSpawnPoint NCSpawn = new neutrinoSpawnPoint(sector, system, 2, 3, NCstation);
		
		CargoAPI NCcargo = NCstation.getCargo();
		
		NCcargo.addCrew(CrewXPLevel.VETERAN, 50);
		NCcargo.addCrew(CrewXPLevel.REGULAR, 100);
		NCcargo.addMarines(200);
		NCcargo.addSupplies(500);
		NCcargo.addFuel(750);
			
		NCcargo.addWeapons("neutrino_photongun", 3);
		NCcargo.addWeapons("neutrino_photontorpedo", 2);
		NCcargo.addWeapons("neutrino_antiproton", 1);
		NCcargo.addWeapons("neutrino_darkmatterbeamcannon", 1);	
		NCcargo.addWeapons("neutrino_tractorbeam", 1);		
		NCcargo.addWeapons("neutrino_heavyphotonrepeater", 2);	
		NCcargo.addWeapons("neutrino_particlecannonarray", 1);			
		NCcargo.addWeapons("neutrino_advancedtorpedo", 1);			
		NCcargo.addWeapons("neutrino_XLadvancedtorpedo", 1);
		
		//Frigates
		
		NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_singularity_standard", null);	
		NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_singularity_standard", null);	
		
		//Destroyers
		
		NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_blowtorch_standard", null);
		NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_hacksaw_standard", null);	
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_hacksaw_assault", null);			
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_vice_standard", null);	
		
		//Cruisers
		
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_piledriver_standard", null);			
		NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_grinder_standard", null);			
		NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_nirvash_standard", null);		
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_nirvash_standard", null);	
		
		//Capitals
		
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_hammer_standard", null);			
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_lathe_standard", null);				
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_jackhammer_standard", null);			
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_nausicaa_standard", null);	
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_hildolfr_standard", null);	
		//NCcargo.addMothballedShip(FleetMemberType.SHIP, "neutrino_banshee_standard", null);
		
		//Fighters
		
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_floh_wing", null);
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_floh_wing", null);		
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_floh_wing", null);		
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_floh_wing", null);		
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_floh_wing", null);		
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_floh_wing", null);
		
		NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_drohne_wing", null);	
		NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_drohne_wing", null);		
		NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_schwarzgeist_wing", null);		
		//NCcargo.addMothballedShip(FleetMemberType.FIGHTER_WING, "neutrino_drache_wing", null);		
	
		// Woo thanks Uomoz, hopefully you won't see this, but credits to you. :D
		
		
		
		
		
		
		system.addSpawnPoint(NCSpawn);
		for (int i = 0; i < 3; i++) NCSpawn.spawnFleet();	

		
		
		
		FactionAPI neutrinocorp = sector.getFaction("neutrinocorp");
		
		
		neutrinocorp.setRelationship("hegemony", 0);
		neutrinocorp.setRelationship("tritachyon", -1);
		neutrinocorp.setRelationship("pirates", -1);
		neutrinocorp.setRelationship("independent", 0);
		neutrinocorp.setRelationship("player", 0);
   		neutrinocorp.setRelationship("lotus_pirates", -1); 		
    
	}
	}
