package data.scripts.world;

import com.fs.starfarer.api.campaign.CampaignFleetAPI;
import com.fs.starfarer.api.campaign.FleetAssignment;
import com.fs.starfarer.api.campaign.LocationAPI;
import com.fs.starfarer.api.campaign.SectorAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;

import data.scripts.world.BaseSpawnPoint;

public class neutrinoSpawnPoint extends BaseSpawnPoint {

	public neutrinoSpawnPoint(SectorAPI sector, LocationAPI location, 
							float daysInterval, int maxFleets, SectorEntityToken anchor) {
		super(sector, location, daysInterval, maxFleets, anchor);
	}

	@Override
	protected CampaignFleetAPI spawnFleet() {
		//if ((float) Math.random() < 0.5f) return null;
		
		String type = null;
		float r = (float) Math.random();
		if (r > 0.45f) {			//	55% (45)
			type = "neutrinoScout";
		} else if (r > 0.30f) {		//	15%
			type = "neutrinoEscort";
		} else if (r > 0.20f) {		//	10%
			type = "neutrinopeaceFleet";
		} else if (r > 0.15f) {		//	5%
			type = "neutrinoeliteEscort";
		} else if (r > 0.05f) {		//	10%
			type = "neutrinolawyerDetachment";						
		} else  {					//	5%
			type = "neutrinobattleFleet";
		}  
		
		CampaignFleetAPI fleet = getSector().createFleet("neutrinocorp", type);
		getLocation().spawnFleet(getAnchor(), 0, 0, fleet);
		
		
		if (type.equals("neutrinoscout") || type.equals("neutrinoEscort") || type.equals("neutrinoeliteEscort") || type.equals("neutrinolawyerDetachment") ||type.equals("neutrinobattleFleet")) {
			fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 10);
			fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
		} else {
			if ((float) Math.random() > 0.8f) {
				fleet.addAssignment(FleetAssignment.RAID_SYSTEM, null, 30);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			} else {
				fleet.addAssignment(FleetAssignment.DEFEND_LOCATION, getAnchor(), 20);
				fleet.addAssignment(FleetAssignment.GO_TO_LOCATION_AND_DESPAWN, getAnchor(), 1000);
			}
		}
		
		return fleet;
	}

}
